# Contributing
Thank you  for your interest in contributing to the Trident project! 🎉

We appreciate that you want to take the time to contribute! Please follow these steps before submitting your PR.

# Creating a Pull Request

1. Please search [existing issues](https://github.com/NetApp/trident/issues) to determine if an issue already exists for what you intend to contribute.
2. If the issue does not already exist, [create a new issue](https://github.com/NetApp/trident/issues/new) that explains the bug or feature request.
3. Let us know in the issue that you plan on creating a pull request for it. This helps us to keep track of the pull request and make sure there isn't duplicate effort.
4. Write up a brief proposal in the issue describing what your change would be and how it would work so that people can comment on it before you go through the effort of doing the work and submitting the PR.
5. Please wait for feedback from someone on NetApp's Trident development team before writing any code. We don't really have an SLA for our feedback, but we will do our best to respond in a timely manner (at least to inform if you are on the right track and that you should proceed, or not).
6. Download NetApp's [Corporate Contributor License Agreement (CCLA)](https://github.com/NetApp/trident/blob/master/CONTRIBUTING_CCLA.pdf). Read, consider your, and/or your company's, agreement to the document, and sign if appropriate. 
7. As instructed in the CCLA, please send the completed document to <legalip@netapp.com>. 
8. If you've made it this far, and have written code that solves the issue, achieves the design you provided, and takes into account whatever comments were provided, then feel free to create your pull request.

Important: ***NetApp will NOT look at the PR or any of the code submitted in the PR if the CCLA is not on file with NetApp Legal.***

# Trident Team's Commitment
While we truly appreciate your efforts on pull requests, we **cannot** make any commitment for when, or if, your PR will be included in the Trident project. Here are a few reasons why:
- There are many factors involved in integrating new code into this project, including things like: support for a wide variety of NetApp backends, proper adherence to our existing and/or upcoming architecture, sufficient functional and/or scenario tests across all backends, etc. In other words, while your bug fix or feature may be perfect as a standalone patch, we must ensure that your code works and can be accomodated for in all of our use cases, configurations, backends, installer, support matrix, etc.
- The Trident team must plan our resources to integrate your code into our code base and CI platform, and depending on the complexity of your PR, we may or may not have the resources available to make it happen in a timely fashion. As much as we would like to, and as much as we like to be "agile", we still have a roadmap of features that comes from Product Management. We will do our best, but it doesn't always happen quickly.
- Sometimes the PR just doesn't fit into our future plans. As stated above, we have a roadmap of things, and you don't necessarily know what's coming down the pike. It's possible that a PR you submit doesn't align with our upcoming plans, thus we won't be able to use it. It's not personal.


Thank you for considering to contribute to the Trident project!

