// Copyright 2020 NetApp, Inc. All Rights Reserved.

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	netappv1 "github.com/netapp/trident/operator/controllers/provisioner/apis/netapp/v1"
	versioned "github.com/netapp/trident/operator/controllers/provisioner/client/clientset/versioned"
	internalinterfaces "github.com/netapp/trident/operator/controllers/provisioner/client/informers/externalversions/internalinterfaces"
	v1 "github.com/netapp/trident/operator/controllers/provisioner/client/listers/netapp/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// TridentProvisionerInformer provides access to a shared informer and lister for
// TridentProvisioners.
type TridentProvisionerInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.TridentProvisionerLister
}

type tridentProvisionerInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewTridentProvisionerInformer constructs a new informer for TridentProvisioner type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewTridentProvisionerInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredTridentProvisionerInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredTridentProvisionerInformer constructs a new informer for TridentProvisioner type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredTridentProvisionerInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.TridentV1().TridentProvisioners(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.TridentV1().TridentProvisioners(namespace).Watch(context.TODO(), options)
			},
		},
		&netappv1.TridentProvisioner{},
		resyncPeriod,
		indexers,
	)
}

func (f *tridentProvisionerInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredTridentProvisionerInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *tridentProvisionerInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&netappv1.TridentProvisioner{}, f.defaultInformer)
}

func (f *tridentProvisionerInformer) Lister() v1.TridentProvisionerLister {
	return v1.NewTridentProvisionerLister(f.Informer().GetIndexer())
}
