// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewEmsConfigModifyParams creates a new EmsConfigModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEmsConfigModifyParams() *EmsConfigModifyParams {
	return &EmsConfigModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEmsConfigModifyParamsWithTimeout creates a new EmsConfigModifyParams object
// with the ability to set a timeout on a request.
func NewEmsConfigModifyParamsWithTimeout(timeout time.Duration) *EmsConfigModifyParams {
	return &EmsConfigModifyParams{
		timeout: timeout,
	}
}

// NewEmsConfigModifyParamsWithContext creates a new EmsConfigModifyParams object
// with the ability to set a context for a request.
func NewEmsConfigModifyParamsWithContext(ctx context.Context) *EmsConfigModifyParams {
	return &EmsConfigModifyParams{
		Context: ctx,
	}
}

// NewEmsConfigModifyParamsWithHTTPClient creates a new EmsConfigModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewEmsConfigModifyParamsWithHTTPClient(client *http.Client) *EmsConfigModifyParams {
	return &EmsConfigModifyParams{
		HTTPClient: client,
	}
}

/* EmsConfigModifyParams contains all the parameters to send to the API endpoint
   for the ems config modify operation.

   Typically these are written to a http.Request.
*/
type EmsConfigModifyParams struct {

	/* Info.

	   Information specification
	*/
	Info *models.EmsConfig

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ems config modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsConfigModifyParams) WithDefaults() *EmsConfigModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ems config modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsConfigModifyParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := EmsConfigModifyParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ems config modify params
func (o *EmsConfigModifyParams) WithTimeout(timeout time.Duration) *EmsConfigModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ems config modify params
func (o *EmsConfigModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ems config modify params
func (o *EmsConfigModifyParams) WithContext(ctx context.Context) *EmsConfigModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ems config modify params
func (o *EmsConfigModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ems config modify params
func (o *EmsConfigModifyParams) WithHTTPClient(client *http.Client) *EmsConfigModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ems config modify params
func (o *EmsConfigModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the ems config modify params
func (o *EmsConfigModifyParams) WithInfo(info *models.EmsConfig) *EmsConfigModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the ems config modify params
func (o *EmsConfigModifyParams) SetInfo(info *models.EmsConfig) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the ems config modify params
func (o *EmsConfigModifyParams) WithReturnRecordsQueryParameter(returnRecords *bool) *EmsConfigModifyParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the ems config modify params
func (o *EmsConfigModifyParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *EmsConfigModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
